---
title: Examine and edit HTML
slug: Tools/Page_Inspector/How_to/Examine_and_edit_HTML
tags:
  - Debugging
  - Firefox
  - Guide
  - Inspector
  - Mozilla
  - Tools
---
<div>{{ToolsSidebar}}</div>

<p>You can examine and edit the page's HTML in the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#HTML_pane">HTML pane</a>.</p>

<h2 id="Navigating_the_HTML">Navigating the HTML</h2>

<h3 id="HTML_breadcrumbs">HTML breadcrumbs</h3>

<p>At the bottom on the HTML pane is a breadcrumbs toolbar. This shows the complete hierarchy through the document for the branch containing the selected element:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16387/HTML_breadcrumbs.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 600px;"></p>

<p>Hovering over a breadcrumb highlights that element in the page.</p>

<p>The breadcrumbs bar has its own <a href="/en-US/docs/Tools/Page_Inspector/Keyboard_shortcuts#Breadcrumbs_bar">keyboard shortcuts</a>.</p>

<h3 id="Searching">Searching</h3>

<p>The Page Inspector's search box matches all markup in the current document and in any frames.</p>

<p>To start searching the markup, click in the search box to expand it or press <kbd>Ctrl</kbd> + <kbd>F</kbd> , or <kbd>Cmd</kbd> + <kbd>F</kbd> on a Mac. There are three types of searches that are performed automatically depending on what you enter, a full text search, a CSS selector search, and an XPath search.</p>

<h4 id="Full_text_search">Full text search</h4>

<p>The full text search will always be executed, independently of what you enter. That allows you to find CSS selectors and XPath expressions occurring within the text.</p>

<h4 id="CSS_selector_search">CSS selector search</h4>

<p>You can search elements by entering a {{Glossary("CSS selector")}}.</p>

<p>As you type, an autocomplete popup shows any class or ID attributes that match the current search term:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16388/search_html.png" style="border: 1px solid black; display: block; height: 402px; margin-left: auto; margin-right: auto; width: 333px;"></p>

<p>Press <kbd>Up</kbd> and <kbd>Down</kbd> to cycle through suggestions, <kbd>Tab</kbd> to choose the current suggestion, then <kbd>Enter</kbd> to select the first node with that attribute.</p>

<p>{{EmbedYouTube("AKBhnfp1Opo")}}</p>

<p>To cycle through matches, press <kbd>Enter</kbd>. You can cycle backwards through matches using  <kbd>Shift</kbd> + <kbd>Enter</kbd>.</p>

<h4 id="XPath_search">XPath search</h4>

<p>It is also possible to search via <a href="/en-US/docs/Web/XPath">XPaths</a>. This allows you to search for specific elements without the conflict of matching words within the text. For example, <code>//a</code> matches all {{HTMLElement("a")}} elements but not the letter "a" within the text content. Furthermore it allows for some more advanced searches like finding elements that start with a specific text, for example.</p>

<p><img alt="Match of an Inspector search using an XPath expression" src="https://mdn.mozillademos.org/files/17139/XPath_search.png" style="border: 1px solid black; display: block; height: 261px; margin-left: auto; margin-right: auto; width: 482px;"></p>

<h3 id="HTML_tree">HTML tree</h3>

<p>The rest of the pane shows you the page's HTML as a tree (this UI is also called the Markup View). Just to the left of each node is an arrow: click the arrow to expand the node. If you hold the Alt key while clicking the arrow, it expands the node and all the nodes underneath it.<img alt="The new Firefox 57 inspector HTML tree." src="https://mdn.mozillademos.org/files/16389/HTML_tree.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 476px;"></p>

<p>Moving the mouse over a node in the tree highlights that element in the page.</p>

<p>Nodes that are not visible are shown faded/desaturated. This can happen for different reasons such as using <code><a href="/en-US/docs/Web/CSS/display">display: none</a></code> or that the element doesn't have any dimensions.</p>

<p>There is an ellipsis shown between the opening and closing tag of an element when the node is collapsed if it has larger contents. Now children are indicated in the tree with this icon: <img alt="" src="https://mdn.mozillademos.org/files/14925/child-node-indicator.png" style="height: 24px; width: 32px;"></p>

<p>Markers ("badges") are displayed to the right of some nodes. The table below explains the meaning of each badge:</p>

<table class="standard-table" id="node-markers">
 <tbody>
  <tr>
   <td><code>event</code></td>
   <td>The element has one or several event listeners attached to it. Clicking the marker opens a tooltip listing the event listeners and allows you for each listener to switch to the line of JavaScript code in the <a href="/en-US/docs/Tools/Debugger">Debugger</a> where the listener is defined.</td>
  </tr>
  <tr>
   <td><code>scroll</code></td>
   <td>The element is a {{Glossary("scroll container")}}, i.e. it has either <code>overflow: scroll</code> applied, or <code>overflow: auto</code> and sufficient content to cause <a href="/en-US/docs/Web/CSS/CSS_Overflow">scrollable overflow</a>.<br>
    <br>
    If preference <code>devtools.overflow.debugging.enabled</code> is <code>true</code>, toggling the <code>scroll</code> badge will highlight any elements causing the overflow, and these nodes will additionally display the <code>overflow</code> badge.</td>
  </tr>
  <tr>
   <td><code>overflow</code></td>
   <td>The element is causing <a href="/en-US/docs/Web/CSS/CSS_Overflow">scrollable overflow</a> in a {{Glossary("scroll container")}} (either the current node or a parent node—the affected node will display the <code>scroll</code> badge).
    <div class="note">
    <p><strong>Note</strong>: The <code>overflow</code> badge is introduced in Firefox 83. In earlier versions it can be enabled using the preference <code>devtools.overflow.debugging.enabled</code> is <code>true</code>.</p>
    </div>
   </td>
  </tr>
  <tr>
   <td><code>grid</code></td>
   <td>The element is a {{Glossary("grid container")}}, i.e. it has <code><a href="/en-US/docs/Web/CSS/display">display: grid</a></code> applied to it. Clicking the marker enables the grid highlighter.</td>
  </tr>
  <tr>
   <td><code>flex</code></td>
   <td>The element is a {{Glossary("flex container")}}, i.e. it has <code><a href="/en-US/docs/Web/CSS/display">display: flex</a></code> applied to it. Clicking the marker enables the flexbox highlighter.</td>
  </tr>
  <tr>
   <td><code>inline-grid</code></td>
   <td>The element is an inline grid container, i.e. it has <code><a href="/en-US/docs/Web/CSS/display">display: inline-grid</a></code> or <code>display: inline grid</code> applied to it. Clicking the marker enables the grid highlighter.</td>
  </tr>
  <tr>
   <td><code>inline-flex</code></td>
   <td>The element is an inline flex container, i.e. it has <code><a href="/en-US/docs/Web/CSS/display">display: inline-flex</a></code> or <code>display: inline flex</code> applied to it. Clicking the marker enables the flexbox highlighter.</td>
  </tr>
  <tr>
   <td><code>custom…</code></td>
   <td>The element is a custom element. Clicking the marker switches to the line of JavaScript code in the Debugger where the custom element got defined.</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note</strong>: There are some useful keyboard shortcuts that can be used in the HTML tree — see the <a href="/en-US/docs/Tools/Keyboard_shortcuts#HTML_pane">HTML pane keyboard shortcuts list</a>.</p>
</div>

<h3 id="before_and_after">::before and ::after</h3>

<p>You can inspect pseudo-elements added using {{cssxref("::before")}} and {{cssxref("::after")}}:</p>

<p>{{EmbedYouTube("ecfqTGvzsNc")}}</p>

<h3 id="Custom_element_definition">Custom element definition</h3>

<p>When you open the Inspector on a page that includes custom elements, you can view the class definition for the custom element in the Debugger:</p>

<ol>
 <li>Inspect the element</li>
 <li>Click on the word <code>custom</code></li>
</ol>

<p><img alt="" src="https://mdn.mozillademos.org/files/16306/custom_pc_01.png" style="display: block; height: 580px; margin: 0px auto; width: 852px;"></p>

<p>The source for the element's class will be displayed in the Debugger.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16307/custom_pc_02.png" style="display: block; height: 290px; margin: 0px auto; width: 852px;"></p>

<h3 id="Whitespace-only_text_nodes">Whitespace-only text nodes</h3>

<p>Web developers don’t write all their code in just one line of text. They use white space such as spaces, returns, or tabs between their HTML elements because it makes markup more readable.</p>

<p>Usually this white space seems to have no effect and no visual output, but in fact, when a browser parses HTML it will automatically generate anonymous text nodes for elements not contained in a node. This includes white space (which is after all a type of text).</p>

<p>If these auto generated text nodes are <a href="/en-US/docs/Web/Guide/CSS/Visual_formatting_model#Inline-level_elements_and_inline_boxes">inline level</a>, browsers will give them a non-zero width and height. Then you will find strange gaps between elements, even if you haven’t set any margin or padding on them.</p>

<p>Since Firefox 52, the Inspector displays these whitespace nodes, so you can see where the gaps in your markup come from. Whitespace nodes are represented with a dot: <img alt="" src="https://mdn.mozillademos.org/files/14931/new-whitespace-text-indicator.png" style="height: 23px; width: 30px;"> and you get an explanatory tooltip when you hover over them:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16394/white_space_only.png" style="display: block; height: 382px; margin-left: auto; margin-right: auto; width: 815px;"></p>

<p>To see this in action, see the demo at <a href="https://mdn.github.io/devtools-examples/whitespace-only-demo/index.html">https://mdn.github.io/devtools-examples/whitespace-only-demo/index.html</a>.</p>

<h3 id="Shadow_roots">Shadow roots</h3>

<p>Any shadow roots present in the DOM are exposed in the HTML page in the same manner as the regular DOM. The shadow root is signified by a node named <code>#shadow-root</code> — you can click its expansion arrow to see the full contents of the shadow DOM, and then manipulate the contained nodes in a similar way to other part of the page's DOM (although with a limited featureset — you can't, for example, drag and drop or delete shadow DOM nodes).</p>

<p><img alt="A view of a shadow root shown inside the DOM tree in the Firefox DevTools" src="https://mdn.mozillademos.org/files/16414/inspector_shadowDom.png" style="display: block; height: 300px; margin: 0 auto; width: 481px;"></p>

<p>If a shadow DOM contains a "slotted" element (an element with a <code>slot</code> attribute after it has been inserted inside a {{htmlelement("slot")}} element — see <a href="/en-US/docs/Web/Web_Components/Using_templates_and_slots#Adding_flexibility_with_slots">Adding flexibility with slots</a> for an explanation of how these are used), the "slotted" element will be shown inside its corresponding {{htmlelement("slot")}} element, with a "reveal" link alongside it. Clicking the "reveal" link will highlight the element with the <code>slot</code> attribute as it exists outside the shadow DOM</p>

<p><img alt="A view of a shadow root shown inside the DOM tree in the Firefox DevTools" src="https://mdn.mozillademos.org/files/16413/inspector_slot.png" style="display: block; height: 300px; margin: 0 auto; width: 481px;"></p>

<p>This is very useful when you've got a <code>&lt;slot&gt;</code> element and you can't find the source of its content.</p>

<div class="note">
<p><strong>Note</strong>: Shadow DOM inspection was implemented in Firefox 61, but was hidden behind the <code>dom.webcomponents.shadowdom.enabled</code> pref until Firefox 63. It is now turned on by default.</p>
</div>

<h2 id="Element_popup_context_menu">Element popup context menu</h2>

<p>You can perform certain common tasks on a specific node using a popup context menu. To activate this menu, context-click the element. The menu contains the following items — click on the links to find the description of each command in the {{anch("Context menu reference")}}:</p>

<ul>
 <li><a href="#Edit_as_HTML">Edit As HTML</a></li>
 <li><a href="#Create_New_Node">Create New Node</a></li>
 <li><a href="#Duplicate_Node">Duplicate Node</a></li>
 <li><a href="#Delete_Node">Delete Node</a></li>
 <li>Attributes
  <ul>
   <li><a href="#Attribute_Add_Attribute">Add Attribute</a></li>
   <li>Copy Attribute Value</li>
   <li><a href="#Attribute_Edit_Attribute">Edit Attribute</a></li>
   <li><a href="#Attribute_Remove_Attribute">Remove Attribute</a></li>
  </ul>
 </li>
 <li>Break on ...
  <ul>
   <li>Subtree Modification</li>
   <li>Attribute Modification</li>
   <li>Node Removal</li>
  </ul>
 </li>
 <li><a href="#Use_in_Console">Use in Console</a></li>
 <li><a href="#Show_DOM_Properties">Show DOM Properties</a></li>
 <li>Show Accessibility Properties</li>
 <li>Change Pseudo-class
  <ul>
   <li><a href="#:hover">hover</a></li>
   <li><a href="#:active">active</a></li>
   <li><a href="#:focus">focus</a></li>
   <li><a href="#focus-within">focus-within</a></li>
   <li><a href="#visited">visited</a></li>
  </ul>
 </li>
 <li><a href="#Screenshot_Node">Screenshot Node</a></li>
 <li><a href="#Scroll_Into_View">Scroll Into View</a></li>
 <li>Copy
  <ul>
   <li><a href="#Copy_Inner_HTML">Inner HTML</a></li>
   <li><a href="#Copy_Outer_HTML">Outer HTML</a></li>
   <li><a href="#Copy_Unique_Selector">CSS Selector</a></li>
   <li><a href="#Copy_CSS_Path">CSS Path</a></li>
   <li>XPath</li>
   <li><a href="#Copy_Image_Data-URL">Image Data-URL</a></li>
   <li><a href="#Copy_Attribute">Attribute</a></li>
  </ul>
 </li>
 <li>Paste
  <ul>
   <li><a href="#Paste_Inner_HTML">Inner HTML</a></li>
   <li><a href="#Paste_Outer_HTML">Outer HTML</a></li>
   <li><a href="#Paste_Before">Before</a></li>
   <li><a href="#Paste_After">After</a></li>
   <li><a href="#Paste_As_First_Child">As First Child</a></li>
   <li><a href="#Paste_As_Last_Child">As Last Child</a></li>
  </ul>
 </li>
 <li><a href="#Expand_All">Expand All</a></li>
 <li><a href="#Collapse">Collapse All</a></li>
 <li><a href="#Open_Link_in_New_Tab">Open Link in New Tab</a> *</li>
 <li><a href="#Open_File_in_Debugger">Open File in Debugger</a> *</li>
 <li><a href="#Open_File_in_Style-Editor">Open File in Style-Editor</a> *</li>
 <li><a href="#Copy_Link_Address">Copy Link Address</a> *</li>
</ul>

<p>* These options only appear in certain contexts, for example the "Open File in Style-Editor" option only appears when you context-click over the top of a link to a CSS file.</p>

<h3 id="Context_menu_reference">Context menu reference</h3>

<table class="standard-table">
 <tbody>
  <tr>
   <td style="width: 30%;"><a id="Edit_as_HTML">Edit as HTML</a></td>
   <td><a href="#Editing_HTML">Edit the element's HTML</a>.</td>
  </tr>
  <tr>
   <td><a id="Copy_Inner_HTML">(Copy) Inner HTML</a></td>
   <td>Copy the inner HTML for the element.</td>
  </tr>
  <tr>
   <td><a id="Copy_Outer_HTML">(Copy) Outer HTML</a></td>
   <td>
    <p>Copy the outer HTML for the element.</p>

    <p>Pressing <kbd>Ctrl</kbd> + <kbd>C</kbd> (or <kbd>Cmd</kbd> + <kbd>C</kbd> on a Mac) also performs this action.</p>
   </td>
  </tr>
  <tr>
   <td><a id="Copy_Unique_Selector">(Copy) Unique Selector/CSS Selector</a></td>
   <td>Copy a CSS selector that uniquely selects the element.</td>
  </tr>
  <tr>
   <td><a id="Copy_CSS_Path">(Copy) CSS Path</a></td>
   <td>Copy a CSS selector that represents the full path to the element.</td>
  </tr>
  <tr>
   <td><a id="Copy_Image_Data-URL">(Copy) Image Data-URL</a></td>
   <td>Copy image as a data:// URL, if the selected element is an image.</td>
  </tr>
  <tr>
   <td><a id="Copy_Attribute">(Copy) Attribute</a></td>
   <td>Copy the attribute of the element.</td>
  </tr>
  <tr>
   <td><a id="Show_DOM_Properties">Show DOM Properties</a></td>
   <td>Open the <a href="/en-US/docs/Tools/Web_Console#The_split_console">split console</a> and enter the console command "<code>inspect($0)</code>" to <a href="/en-US/docs/Tools/Web_Console#Inspecting_objects">inspect</a> the currently selected element.</td>
  </tr>
  <tr>
   <td><a id="Use_in_Console">Use in Console</a></td>
   <td>Assigns the currently selected node to a variable named <code>temp0</code> (or <code>temp1</code> if <code>temp0</code> is already taken, and so on), then opens the <a href="/en-US/docs/Tools/Web_Console#The_split_console">split console</a>, enabling you to interact with that node using the console's command line.</td>
  </tr>
  <tr>
   <td><a id="Expand_All">Expand All</a></td>
   <td>In the tree view, expand the current element and all the elements underneath it. This is equivalent to holding the <kbd>Alt</kbd> key and clicking the disclosure triangle next to an element.</td>
  </tr>
  <tr>
   <td><a id="Collapse">Collapse</a></td>
   <td>In the tree view, collapse the current element. This is equivalent to clicking the disclosure arrow next to an element that's expanded.</td>
  </tr>
  <tr>
   <td><a id="Paste_Inner_HTML">(Paste) Inner HTML</a></td>
   <td>Paste the clipboard contents into the node as its <a href="/en-US/docs/Web/API/element.innerHTML">innerHTML</a>.</td>
  </tr>
  <tr>
   <td><a id="Paste_Outer_HTML">(Paste) Outer HTML</a></td>
   <td>Paste the clipboard contents into the node as its <a href="/en-US/docs/Web/API/element.outerHTML">outerHTML</a>.</td>
  </tr>
  <tr>
   <td><a id="Paste_Before">(Paste) Before</a></td>
   <td>Paste the clipboard contents into the document immediately before this node.</td>
  </tr>
  <tr>
   <td><a id="Paste_After">(Paste) After</a></td>
   <td>Paste the clipboard contents into the document immediately after this node.</td>
  </tr>
  <tr>
   <td><a id="Paste_As_First_Child">(Paste) As First Child</a></td>
   <td>Paste the clipboard contents into the document as the first child of this node.</td>
  </tr>
  <tr>
   <td><a id="Paste_As_Last_Child">(Paste) As Last Child</a></td>
   <td>Paste the clipboard contents into the document as the last child of this node.</td>
  </tr>
  <tr>
   <td><a id="Scroll_Into_View">Scroll Into View</a></td>
   <td>
    <p>Scrolls the web page so the selected node is visible.</p>

    <p>From Firefox 44, pressing the keyboard shortcut <kbd>S</kbd> will also scroll the selected node into view.</p>
   </td>
  </tr>
  <tr>
   <td><a id="Screenshot_Node">Screenshot Node</a></td>
   <td>Takes a screenshot of the selected node, saved to your Downloads directory. See <a href="/en-US/docs/Tools/Taking_screenshots">Taking screenshots</a>.</td>
  </tr>
  <tr>
   <td><a id="Create_New_Node">Create New Node</a></td>
   <td>Create a new empty &lt;div&gt; as the last child of the currently selected element. See <a href="#Inserting_new_nodes">Inserting new nodes</a>.</td>
  </tr>
  <tr>
   <td><a id="Duplicate_Node">Duplicate Node</a></td>
   <td>Create a copy of this element, and insert the copy immediately after this element.</td>
  </tr>
  <tr>
   <td><a id="Delete_Node">Delete Node</a></td>
   <td>Delete the element from the DOM.</td>
  </tr>
  <tr>
   <td><a id="Attribute_Add_Attribute">Attribute/Add Attribute</a></td>
   <td>Add an attribute to the element.</td>
  </tr>
  <tr>
   <td><a id="Attribute_Edit_Attribute">Attribute/Edit Attribute</a></td>
   <td>(only when invoked on an attribute) Edit the attribute.</td>
  </tr>
  <tr>
   <td><a id="Attribute_Remove_Attribute">Attribute/Remove Attribute</a></td>
   <td>(only when invoked on an attribute) Remove the attribute.</td>
  </tr>
  <tr>
   <td><a id="Open_Link_in_New_Tab">Open Link in New Tab</a></td>
   <td>(only when invoked over a link, such as an href attribute) Opens the linked item in a new tab.</td>
  </tr>
  <tr>
   <td><a id="Open_File_in_Debugger">Open File in Debugger</a></td>
   <td>(only when invoked over a link to a JS source) Opens the linked source in the Debugger.</td>
  </tr>
  <tr>
   <td><a id="Open_File_in_Style-Editor">Open File in Style-Editor</a></td>
   <td>(only when invoked over a link to a CSS source) Opens the linked source in the Style Editor.</td>
  </tr>
  <tr>
   <td><a id="Copy_Link_Address">Copy Link Address</a></td>
   <td>(only when invoked over a URL) Copy the URL.</td>
  </tr>
  <tr>
   <td><a id=":hover">(Change Pseudo-class) hover</a></td>
   <td>Set the <a href="/en-US/docs/Web/CSS/:hover">:hover</a> CSS pseudo-class.</td>
  </tr>
  <tr>
   <td><a id=":active">(Change Pseudo-class) active</a></td>
   <td>Set the <a href="/en-US/docs/Web/CSS/:active">:active</a> CSS pseudo-class.</td>
  </tr>
  <tr>
   <td><a id=":focus">(Change Pseudo-class) focus</a></td>
   <td>Set the <a href="/en-US/docs/Web/CSS/:focus">:focus</a> CSS pseudo-class.</td>
  </tr>
  <tr>
   <td><a id="focus-within">(Change Pseudo-class) focus-within</a></td>
   <td>Set the :focus-within CSS pseudo-class.</td>
  </tr>
  <tr>
   <td><a id="visited">(Change Pseudo-class) visited</a></td>
   <td>Set the :visited CSS pseudo-class.</td>
  </tr>
 </tbody>
</table>

<h2 id="Editing_HTML">Editing HTML</h2>

<p>You can edit the HTML — tags, attributes, and content — directly in the HTML pane: double-click the text you want to edit, change it, and press Enter to see the changes reflected immediately.</p>

<p>To edit an element's {{domxref("Element.outerHTML", "outerHTML")}}, activate the element's popup menu and select "Edit As HTML". You'll see a text box in the HTML pane:</p>

<p><img alt="Edit HTML directly in the Inspector panel in Firefox 57" src="https://mdn.mozillademos.org/files/16395/edit_html.png" style="border: 1px solid black; display: block; height: 335px; margin-left: auto; margin-right: auto; width: 600px;">You can add any HTML in here: changing the element's tag, changing existing elements, or adding new ones. Once you click outside the box, the changes are applied to the page.</p>

<p>When you're editing HTML, the context menu you'll see is the normal one for working with editable text:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/14522/editable-context-menu.png" style="display: block; height: 241px; margin-left: auto; margin-right: auto; width: 200px;"></p>

<h3 id="Copy_and_paste">Copy and paste</h3>

<p>You can use the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Element_popup_menu">popup menu</a> to copy nodes in the HTML tree and paste them into the desired location.</p>

<h3 id="Drag_and_drop">Drag and drop</h3>

<p>You can reorganize the HTML content of a page by moving nodes in the HTML tree. Just click and hold on any element and drag it up or down in the tree. When you release the mouse button, the element will be inserted at the corresponding position:</p>

<p>{{EmbedYouTube("oI-a035nfWk")}}</p>

<p>You can cancel the drag and drop by pressing the <kbd>Esc</kbd> key.</p>

<h3 id="Inserting_new_nodes">Inserting new nodes</h3>

<p>There's a "+" icon at the top of the markup view:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16389/HTML_tree.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 476px;"></p>

<p>Click this icon to insert an empty {{HTMLElement("div")}} into the document as the last child of the currently selected element. You can then edit the new node's content and styling just as you would any other node in the document.</p>

<p>{{EmbedYouTube("NG5daffvVZM")}}</p>

<p>You can access the same functionality using the "Create New Node" popup menu item.</p>

<p>Note that this button is disabled if the selected element's type is such that adding a last-child would have no effect (for example, if it is an {{HTMLElement("html")}} or {{HTMLElement("iframe")}} element). However, it is enabled in places where it is not valid to insert a {{HTMLElement("div")}}, such as {{HTMLElement("style")}} or {{HTMLElement("link")}}. In these cases the element is added as text.</p>
